/*

Copyright c 2013 Xyleme, Inc., 1881 9th Street, Suite 300, Boulder, Colorado 80302 USA.
All rights reserved.

This file and related documentation are protected by copyright and
are distributed under licenses regarding their use, copying, distribution,
and decompilation. No part of this product or related documentation may
be reproduced or transmitted in any form or by any means, electronic or
mechanical, for any purpose, without the express written permission of
Xyleme, Inc.

*/

var MIN_TEXT_WIDTH = 100;
scorableContent = true;   //Used by CRE to determine if the page is scorable               // defined in questions.js
GS = true

//global vars. bad practice
var chosenGameElemId = null;
var gsQuestions = new Array();
var gsoutlinemaps = new Array();
var gsOffsets = new Array();
var passedGsQuestions = new Array();
//var gsCorrectAnswers = 0;

InitGSHotSpot();

function InitGSHotSpot() {	
	addEvent(document, 'mousedown', gameshowOnMouseDown);
}

function gameshowOnMouseDown(e) {
    // IE is retarded and doesn't pass the event object
    if (e == null)
        e = window.event;
    // IE uses srcElement, others use target
    var target = e.target != null ? e.target : e.srcElement;
    var id = target.id;
	
	if(typeof(id)=="undefined" || id.indexOf("GsLinkSpot") != 0)
		return;
	id = 'div' + id;
	var element = document.getElementById(id);
	if (typeof(element) == 'undefined') {
	    return;
	}
	// for IE, left click == 1
    // for Firefox, left click == 0
    if (e.button == 1 && window.event != null || e.button == 0)
    {                  
          // grab the mouse position
          var posx = 0;
          var posy = 0;
          if (!e) var e = window.event;
          if (e.PageX || e.PageY) {
               posx = e.PageX;
               posy = e.PageY;
          }
          else if (e.clientX || e.clientY) {
               posx = e.clientX + document.documentElement.scrollLeft;
               posy = e.clientY + document.documentElement.scrollTop;
          }
		posx += 10;
		posy += 10; //target.offsetHeight*2/3;		
		var width = target.offsetWidth;		
		if (element.innerHTML.length > MIN_TEXT_WIDTH && width < MIN_TEXT_WIDTH)
			width = MIN_TEXT_WIDTH * 2;

		// To play flash under IE
		var flashMovie = getFlashMovieObject("FlashMovie");
		
		if (flashMovie != null && typeof(flashMovie) != 'undefined') {
			if (flashMovie != null && typeof(flashMovie) != 'undefined') {
				for (var k=0; k < flashMovie.length; k++) {
					if (isDecendant(flashMovie[k], element)) {					
						try {
							flashMovie[k].Play();
						}
						catch(err) {
						}
					}
				}
			}
		}
    }
}

function getGsOffset(element, wrap) {
	if(element.children) {
		for(var i=0; i<element.children.length; i++)
		{
			if(element.children[i].name == "GameShowRect")
			{
				return element.children[i].offsetLeft;
			}
		}
	} else {
		var children = element.childNodes;
		for(var i=0; i<element.childNodes.length; i++)
		{
			if(element.childNodes[i].name == "GameShowRect")
			{
				return element.childNodes[i].offsetLeft;
			}
		}
	}
	return 0;
}

function GameshowQuestion() {
    this.randomize = false;
	this.minCorrect = 0;
	this.maxCorrect = 0;
	this.questionsNumber = 0;
    this.redraw = function () {
		
		var img;
		var pickedElem;

			var sources = getElementsByName("div","divGsLinkSpot");
			var qurrentQuestion;
			for (var i = 0; i < sources.length; i++) {
				var children = sources[i].getElementsByTagName("*");
				for (var j=0;j < children.length;j++) {
					if (typeof(children[j].name)!='undefined'
						&& (children[j]).name.indexOf("QuestionForm_") >= 0) {
						qurrentQuestion = getQuestion(children[j].id.substr(children[j].id.lastIndexOf('_')+1));
						break;
					}
				} 			

				if (typeof(qurrentQuestion) != 'undefined' || qurrentQuestion != null ) {
					var elemNumber = sources[i].id.substr(13);
					pickedElem = document.getElementById(sources[i].id.substr(3));
					
					if (qurrentQuestion.getParamValue("result") == "correct") { /////////// CORRECT ANSWER!
						passedGsQuestions.push(qurrentQuestion.guid);
						var results = document.getElementById("score_gs_source_item_" + this.guid);
						var sum = parseInt(results.getAttribute("points")) + parseInt(pickedElem.getAttribute("points"));
						results.setAttribute("points", sum); 
						results.innerHTML = sum;
						img ="<a href='javascript:renderGsPopup(&quot;divGsLinkSpot"+elemNumber+"&quot;,&quot;"+this.guid+"&quot;)'"+
							" style='display: block; width: 60px; text-decoration: none;'><img id='right_gs_source_item_"+
							elemNumber+"' style='left: 20px; top: 1px; position: absolute; border: 0;'"+
							" src='" + img_path + "green_check.gif'/>&nbsp;</a>";
					} else if(qurrentQuestion.getParamValue("result") == "incorrect"){ ///////// INCORRECT ANSWER!
						passedGsQuestions.push(qurrentQuestion.guid);
						img = "<a href='javascript:renderGsPopup(&quot;divGsLinkSpot"+elemNumber+"&quot;,&quot;"+this.guid+"&quot;)'"+
							" style='display: block; width: 60px; text-decoration: none;'><img id='wrong_gs_source_item_"+
							elemNumber+"' style='left: 20px; top: 1px; position: absolute; border: 0;'"+
							" src='" + img_path + "red_x.gif'/>&nbsp;</a>"; 
					} else { ///////// user does not answer yet
						continue;
					}
					pickedElem.innerHTML = img;
				}
			}
	}
}

// Extend basic Question type
GameshowQuestion.prototype = new Question;

// --------------------------------------
// --- add question to question array ---
function addGameshowQuestion(question) {
    gsQuestions[gsQuestions.length] = question;
    addQuestion(question);
}

// -------------------------------------------------
// --- set parameters for all questions in array ---
function setGameshowQuestions() {
	// not forms but divs
	var questionForms  = getElementsByName("div","QuestionForm");
	
    for (l=0; l < questionForms.length; l++) {
        var fid = questionForms[l].id;
        if (fid.toLowerCase().indexOf("gameshow") == -1) continue;

        var wab_id = fid.substr(9);
        
        var wab_obj = document.getElementById("wab_"+wab_id);
        newGameshowQuestion = new GameshowQuestion();
        newGameshowQuestion.setParam("guid", wab_id);

        newGameshowQuestion.setParam("attempts", 
                wab_obj.getAttribute("wab_AttemptLimit"));      
        newGameshowQuestion.setParam("showHint", 
                wab_obj.getAttribute("wab_ShowHint"));  
        newGameshowQuestion.setParam("showFeedback", 
                wab_obj.getAttribute("wab_ShowFeedback"));      
        newGameshowQuestion.setParam("hintActive", 
                wab_obj.getAttribute("wab_hint_active"));       
        newGameshowQuestion.setParam("corectAnswer", "");
        newGameshowQuestion.setParam("rollupWeight", 
                wab_obj.getAttribute("wab_RollupWeight"));
        newGameshowQuestion.setParam("questionsNumber", 
                wab_obj.getAttribute("wab_QuestionsNumber"));
        newGameshowQuestion.setParam("minPassingScore", 
                wab_obj.getAttribute("wab_MinPassingScore"));
        
                
        for (var j=0; j<questions.length; j++) {
            subwabid = "wab_" + questions[j].guid;
            if (jQuery("input[id*='" + subwabid + "']", questionForms[l]).length > 0) {
                questions[j].setParam("isSubQuestion", true);
                questions[j].setParam("parentQuestion", wab_id);
            }
        }
        
        addGameshowQuestion(newGameshowQuestion);
    }
}

// ------------------------------------------------------------
// --- handling submited form of GameshowQuestion ---
function handleGameshow(chosenQuestId, qid, msg, redraw) {
	// retrieving rendered div element (window with question)
	var popupElement = document.getElementById(chosenQuestId);
	// retrieving rendered div element (window with question)
	while (popupElement.id.indexOf("divGsLinkSpot") < 0) {
		popupElement = popupElement.parentNode;
	}
	hideGsPopup(popupElement);
	var currentQuestion = getQuestion(qid);
	var index = 0;//popupElement.id.substr(11);
	
	var gameshowId;
	var currentGameshow;
	
	
	var questionForms  = getElementsByName("div","QuestionForm");
	 for (l=0; l < questionForms.length; l++) {
        var fid = questionForms[l].id;
		
        if (fid.toLowerCase().indexOf("gameshow") == -1) continue;

        gameshowId = fid.substr(9);
		currentGameshow = getQuestion(gameshowId);
	} 

	var at_limit = currentGameshow.getParamValue("attempts");
    var shint = currentGameshow.getParamValue("showHint");	
	var wasQuestionPassed = false;	

	for (var i=0; i < passedGsQuestions.length; i++) {
		if (passedGsQuestions[i] == qid) {
			wasQuestionPassed = true;
		} 
	}

	if (!wasQuestionPassed) {
		var blinkingButton;
		var img;
		var flashingResponse = document.getElementById("flashing_gs_source_item_" + gameshowId);	
		var isGameshowDone;
		//substr number from id
		var elemNumber = popupElement.id.substr(13);
		// body's margins
		var bLeftMargin = 45;
		var bTopMargin = 30;
		var imgHeight = 20;
		var imgWidth = 26;
		var pickedElem = document.getElementById("GsLinkSpot" + elemNumber);
		
		passedGsQuestions.push(qid);
		if (!redraw) {
			if (currentQuestion.getParamValue("result") == "correct") { /////////// CORRECT ANSWER!
				//gsCorrectAnswers = gsCorrectAnswers + 1;
				
				var results = document.getElementById("score_gs_source_item_" + gameshowId);
				var sum = parseInt(results.getAttribute("points")) + parseInt(pickedElem.getAttribute("points"));
				results.setAttribute("points", sum); 
				results.innerHTML = sum;
				
				blinkingButton = document.getElementById("right_blink_gs_source_item_" + gameshowId);
				flashingResponse.innerHTML = "Correct";
				flashingResponse.style.left = "9px";
				img = "<a href='javascript:renderGsPopup(&quot;divGsLinkSpot"+elemNumber+"&quot;,&quot;"+qid+"&quot;)'"+
					" style='display: block; width: 60px; text-decoration: none;'><img id='right_gs_source_item_"+
					elemNumber+"' style='left: 20px; top: 1px; position: absolute; border: 0;'"+
					" src='" + img_path + "green_check.gif'/>&nbsp;</a>";
				playSound("tada");
			} else { ///////// INCORRECT ANSWER!
				blinkingButton = document.getElementById("wrong_blink_gs_source_item_" + gameshowId);
				flashingResponse.innerHTML = "Incorrect";
				flashingResponse.style.left = "6px";
				img = "<a href='javascript:renderGsPopup(&quot;divGsLinkSpot"+elemNumber+"&quot;,&quot;"+qid+"&quot;)'"+
					" style='display: block; width: 60px; text-decoration: none;'><img id='wrong_gs_source_item_"+
					elemNumber+"' style='left: 20px; top: 1px; position: absolute; border: 0;'"+
					" src='" + img_path + "red_x.gif'/>&nbsp;</a>"; 
				
				playSound("chimes");
			}
		}
		pickedElem.innerHTML = img;
		blinkTarget(flashingResponse.id, 6,0,400);
		blinkTarget(blinkingButton.id, 6,0,500);
	}
	
	if (passedGsQuestions.length < currentGameshow.getParamValue("questionsNumber")) {
		isGameshowDone = false;
	} else {
		isGameshowDone = true;
	}

	if (isGameshowDone) {
		var resultElems = getElementsByName("div","divGameResults");
		var gsUserPoints = document.getElementById("score_gs_source_item_" + gameshowId).getAttribute("points");
		var passingScore = currentGameshow.getParamValue("minPassingScore");
		if(Number(gsUserPoints) >= Number(passingScore))
			currentGameshow.setParam("result", "correct");
		else
			currentGameshow.setParam("result", "incorrect");

		for  (var i = 0; i < resultElems.length; i++) {
			var mincorrect_res = parseInt(resultElems[i].getAttribute("minCorrect"));
			var maxcorrect_res = parseInt(resultElems[i].getAttribute("maxCorrect"));
					if ((mincorrect_res <= gsUserPoints) 
						&& (gsUserPoints <= maxcorrect_res) && mode != "review") {
					renderGsPopup(resultElems[i].id);
				} 
		}
		
		if (at_limit > 0) {
			at_limit -= 1;
			currentGameshow.setParam("attempts",at_limit);
			currentGameshow.setParam("userAnswer", gameshowId + "|" + gsUserPoints);
			currentGameshow.setUserResult();//send result to CRE here!
			setUserResults();
		}
		
	}
}
 
var cachedGsOnMouseOut = new Array();
var	cachedGsOnMouseDown = new Array();
var	cachedGsOnMouseOver = new Array();
	
function removeGsOnMouseEvents() {
	for (var i=0; i < GS_HOT_SPOT_COUNT; i++) {

		var elem = document.getElementById('GsLinkSpot' + i);
		if (elem != null) {
			cachedGsOnMouseOut[i] = elem.onmouseout;
			cachedGsOnMouseDown[i] = elem.onmousedown;
			cachedGsOnMouseOver[i] = elem.onmouseover;
			elem.onmouseout = null;
			elem.onmousedown = null;
			elem.onmouseover = null;
		}
	}    
}

function renewGsOnMouseEvents() {
	for (var i=0; i < GS_HOT_SPOT_COUNT; i++) {

		var elem = document.getElementById('GsLinkSpot' + i);
		if (elem != null) { 
			elem.onmouseout = cachedGsOnMouseOut[i];
			elem.onmousedown = cachedGsOnMouseDown[i];
			elem.onmouseover = cachedGsOnMouseOver[i];
		}
	}    
}
  
function renderGsPopup(chosenAnwId, qid) {
	removeGsOnMouseEvents();
	chosenGameElemId = chosenAnwId.substring(3);
	
	var popupWindow  = document.getElementById("GSPopup");
	popupWindow.style.display = "block";
	popupWindow.style.visibility = "visible";	
	
	var popupQuestion = document.getElementById(chosenAnwId);
	popupQuestion.className = "gsShownContent";
	popupQuestion.style.left = "45px";
	popupQuestion.style.top = "60px";
	popupQuestion.style.display = "block"; 
	popupQuestion.style.visibility = "visible";
	if (qid) {
		if (jQuery(popupQuestion).find("a,input").eq(0)[0].disabled){
			jQuery(popupQuestion).find("div .Submit > input[id*='_doneBtn']").focus();
		} else {
			jQuery(popupQuestion).find("a,input").eq(0).focus();
		}
		
	}
}


function hideGsPopup(popupElement) {
	// retrieving rendered div element (window with question)
	popupElement.className = "gsHiddenContent";
	popupElement.style.display = "none"; 
	popupElement.style.visibility = "hidden";
	document.getElementById("GSPopup").style.display = "none";
	renewGsOnMouseEvents();
	
	if (chosenGameElemId) {
		jQuery("#"+chosenGameElemId).find("a").focus();
	}
}

function blinkTarget(id , neededBlings, blinkingCounter, timeout, isRepeatedly) {
	var target = document.getElementById(id);

	if(target.style.visibility=='hidden') {
		target.style.visibility='visible';
		blinkingCounter = blinkingCounter + 1;
		if (isRepeatedly){
			neededBlings = blinkingCounter + 1;
		}
	} else {
		target.style.visibility='hidden';
	}
	
	if (blinkingCounter < neededBlings){
		setTimeout("blinkTarget('"+id+"',"+neededBlings+","+blinkingCounter+","+timeout+","+isRepeatedly+")", timeout);	
	} else {
		target.style.visibility='hidden';
	}		
	return true;
}

function blinkUpArrow(id) {
	var target = document.getElementById(id);
	if (target!=null) {
		var idCounter = parseInt(id.substr(23));
		
		if (idCounter == 4) {
			var previousIdCounter = 0;
		} else {
			var previousIdCounter = idCounter + 1;
		}
		
		var prevTarget = document.getElementById("uparrow_gs_source_item_" + previousIdCounter);

		if (target.style.visibility=='hidden') {
			target.style.visibility='visible';
			prevTarget.style.visibility='hidden';
		} else {
			target.style.visibility='hidden';
			prevTarget.style.visibility='hidden';
		}
		
		if (idCounter > 0) {
			idCounter--;
		} else {
			idCounter = 4;
		}

		setTimeout("blinkUpArrow('uparrow_gs_source_item_"+idCounter+"')", 400);
		return true;
	} 
}

function blinkDownArrow(id) {
	var target = document.getElementById(id);
	
	if (target != null) {
		var idCounter = parseInt(id.substr(25));
		
		if (idCounter == 0) {
			var previousIdCounter = 4;
		} else {
			var previousIdCounter = idCounter - 1;
		}
		
		var prevTarget = document.getElementById("downarrow_gs_source_item_" + previousIdCounter);

		if (target.style.visibility=='hidden') {
			target.style.visibility='visible';
			prevTarget.style.visibility='hidden';
		} else {
			target.style.visibility='hidden';
			prevTarget.style.visibility='hidden';
		}
		
		if (idCounter < 4) {
			idCounter++;
		} else {
			idCounter = 0;
		}

		setTimeout("blinkDownArrow('downarrow_gs_source_item_"+idCounter+"')", 400);
		return true;
	}
}

function gameShowLightsOn() {
		blinkDownArrow("downarrow_gs_source_item_" + 0);
		blinkUpArrow("uparrow_gs_source_item_" + 4);
}

function arrangeGameshowObjects(type) {	
	var sources = getElementsByName("div","GameShowRect");
	var offsets;
	
	for (var i = 0; i < sources.length; i++ ) {
		offsets = getGameShowOffsets(sources[i],type);
		sources[i].style.top = ExtractNumber(sources[i].style.top) + offsets[0] + 'px';
		sources[i].style.left = ExtractNumber(sources[i].style.left) + offsets[1] + 'px';
	}
}

function getGameShowOffsets(obj, type) {
	var curleft = curtop = 0;
	
	curleft = -45 - (jQuery("img.gsMapImg").offset().left - 90);
	
	/*due to IE 6 problems*/
	if (navigator.appVersion.indexOf("MSIE 6") !=-1){
		curleft -= 65;
	}
	/*due to IE 6 problems*/

	return [curtop,curleft];
}
//======================================================================
/**
/* play .wav files immediately
**/
var soundEmbed = null;
function playSound(soundobj) {
    if (!soundEmbed)
        {
        soundEmbed = document.createElement("embed");
        soundEmbed.setAttribute("src", img_path + soundobj + ".wav");
        soundEmbed.setAttribute("hidden", true);
        soundEmbed.setAttribute("autostart", true);
        }
    else
        {
        document.body.removeChild(soundEmbed);
        soundEmbed.removed = true;
        soundEmbed = null;
        soundEmbed = document.createElement("embed");
        soundEmbed.setAttribute("src", img_path + soundobj + ".wav");
        soundEmbed.setAttribute("hidden", true);
        soundEmbed.setAttribute("autostart", true);
        }
    soundEmbed.removed = false;
    document.body.appendChild(soundEmbed);  
}  
//======================================================================

// -------------------------------
// --- init the whole CRE page ---
function initGameshowPage() {   
    setGameshowQuestions();
    getUserResults(gsQuestions);
	var contentCover = document.getElementById('GSContentCover');
    if(contentCover) {
		/*done to make offsets correct in questions (prevent dragging objects' shifting) */
		var container = document.getElementById("gsQuestionsContainer");
		for (var i = 0 ; i < container.childNodes.length; i++){
			container.childNodes[i].className = "gsHiddenContent";
		}
		container = document.getElementById("gsPopupContainer");
		for (var i = 0 ; i < container.childNodes.length; i++){
			if(container.childNodes[i].nodeName != '#text'){
			container.childNodes[i].className = "gsHiddenContent";
				}
		}
		/***/
		contentCover.style.display = 'none';
		contentCover.style.visibility = 'hidden';
    }
	gameShowLightsOn();
}
 
//window.onload = initQuestionPage();
