/*

Copyright c 2013 Xyleme, Inc., 1881 9th Street, Suite 300, Boulder, Colorado 80302 USA.
All rights reserved.

This file and related documentation are protected by copyright and
are distributed under licenses regarding their use, copying, distribution,
and decompilation. No part of this product or related documentation may
be reproduced or transmitted in any form or by any means, electronic or
mechanical, for any purpose, without the express written permission of
Xyleme, Inc.

*/

var MIN_TEXT_WIDTH = 100;
scorableContent = true;   //Used by CRE to determine if the page is scorable               // defined in questions.js
IMQ = true
var isQuestionDone = false;

var imqQuestions = new Array();
var imqoutlinemaps = new Array();
var imqOffsets = new Array();
var imqOverlayId;
var globoffsetLeft = 0;
var globoffsetTop = 0;
var j$ = jQuery.noConflict();
var selectedArea = null;
InitQuizHotSpot();
// feedback images size
var imgHeight = 20;
var imgWidth = 26;
var passedIMQQuestions = new Array();
var imqCorrectAnswers = 0;

function InitQuizHotSpot() {	
	addEvent(document, 'mousedown', quizOnMouseDown);
}

function imqHideAll() {
	for (var i=0; i < IMQ_HOT_SPOT_COUNT; i++) {
		var elem = document.getElementById('divImqLinkSpot' + i);
		if (typeof(elem) != 'undefined' && elem != null) {
			elem.style.visibility = 'hidden';
			elem.style.display = 'none';
			
			//TODO: Add multi flash objects support (on the same page in IE)
			var flashMovie = getFlashMovieObject("FlashMovie");

			if (flashMovie != null && typeof(flashMovie) != 'undefined') {
				for (var k=0; k < flashMovie.length; k++) {
					if (isDecendant(flashMovie[k], elem)) {				
						try {
							flashMovie[k].Rewind();
						}
						catch(err) {
						}
					}
				}
			}
		}
	}
	for(var i=0; i<imqoutlinemaps.length; i++)
		if(imqoutlinemaps[i] != null)
			imqoutlinemaps[i].clear();
}
function quizOnMouseDown(e) {  
    // IE is retarded and doesn't pass the event object
    if (e == null)
        e = window.event; 	
    // IE uses srcElement, others use target
    var target = e.target != null ? e.target : e.srcElement;
    var id = target.id;
	
	if(typeof(id) == "undefined" || id.indexOf("ImqLinkSpot") != 0)
		return;
	id = 'div' + id;
	var element = document.getElementById(id);
	if (typeof(element) == 'undefined') {
	    return;
	}
	// for IE, left click == 1
    // for Firefox, left click == 0
    if (e.button == 1 && window.event != null || e.button == 0)
    {                  
          // grab the mouse position
          var posx = 0;
          var posy = 0;
          if (!e) var e = window.event;
          if (e.PageX || e.PageY) {
               posx = e.PageX;
               posy = e.PageY;
          }
          else if (e.clientX || e.clientY) {
               posx = e.clientX + document.documentElement.scrollLeft;
               posy = e.clientY + document.documentElement.scrollTop;
          }
		posx += 10;
		posy += 10; //target.offsetHeight*2/3;		
		var width = target.offsetWidth;		
		if (element.innerHTML.length > MIN_TEXT_WIDTH && width < MIN_TEXT_WIDTH)
			width = MIN_TEXT_WIDTH * 2;
		/*
		if (IMQ_DISPLAY_AREA_SPECIFIED != null && IMQ_DISPLAY_AREA_SPECIFIED) {
			element.className= 'imqShownContent';
			element.style.display = 'block';
			element.style.visibility = 'visible';
		} 
		else {		
			element.style.display = 'block';
			element.style.visibility = 'visible';
			element.style.left = posx - element.offsetParent.offsetLeft + "px";		
			element.style.top = posy - element.offsetParent.offsetTop + "px";		
			
		}
		*/
		drawImqFigure(target, true);

		// To play flash under IE
		var flashMovie = getFlashMovieObject("FlashMovie");
		
		if (flashMovie != null && typeof(flashMovie) != 'undefined') {
			if (flashMovie != null && typeof(flashMovie) != 'undefined') {
				for (var k=0; k < flashMovie.length; k++) {
					if (isDecendant(flashMovie[k], element)) {					
						try {
							flashMovie[k].Play();
						}
						catch(err) {
						}
					}
				}
			}
		}
    }
}
function drawImqFigure(target, isRemoveMouseDownEventEnabled) {

	var index = parseInt(target.parentNode.name.substring(6));

	if(imqoutlinemaps[index] != null) {
		imqoutlinemaps[index].clear();
		var coords = target.coords.split(',');
		
		if(target.shape.toLowerCase() == "rect") {
			imqoutlinemaps[index].drawRect(parseInt(coords[0]) + parseInt(imqOffsets[index]), parseInt(coords[1]), coords[2]-coords[0], coords[3]-coords[1]);
		} else if(target.shape.toLowerCase() == "circle"){
			imqoutlinemaps[index].drawEllipse((coords[0]-coords[2]) + parseInt(imqOffsets[index]), coords[1]-coords[2], 2 * parseInt(coords[2]), 2 * parseInt(coords[2]));
		} else 	if (target.shape.toLowerCase() == "poly") {
			var xs = new Array();
			for(var i=0; i<coords.length/2; i++)
				xs[i] = parseInt(coords[2*i]) + parseInt(imqOffsets[index]);
			var ys = new Array();
			for(var i=0; i<coords.length/2; i++)
				ys[i] = parseInt(coords[2*i+1]);
			imqoutlinemaps[index].drawPolygon(xs, ys);
		}
		imqoutlinemaps[index].paint();
	}
	
	if (isRemoveMouseDownEventEnabled) {
		removeEvent(document, 'mousedown', quizOnMouseDown);
	}
}

function showContent(elemID) {	
	
	// NOT IMPLEMENTED FOR MOUSE OVER

/*	var element = document.getElementById(elemID);
	if(typeof(element) == 'undefined')	
	    return;
	
	hideAll();
	
	if (DISPLAY_AREA_SPECIFIED != null && DISPLAY_AREA_SPECIFIED) {
			element.className= 'showedContent';
			element.style.display = 'block';
			element.style.visibility = 'visible';
		} else {		
			element.style.display = 'block';
			element.style.visibility = 'visible';
			element.style.left = posx + "px";		
			element.style.top = posy + "px";		
			element.style.width = width + "px";
		}*/
}

function ImageMapQuizQuestion(){
    this.randomize = false;
	this.minCorrect = 0;
	this.maxCorrect = 0;
	this.questionsNumber = 0;
    this.redraw = function () {
		var img;
		
			var sources = getElementsByName("div","divImqLinkSpot");
			var qurrentQuestion;
			for (var i = 0; i < sources.length; i++) {
				var children = sources[i].getElementsByTagName("*");
				for (var j=0;j < children.length;j++) {
					if (typeof(children[j].name)!='undefined'
						&& (children[j]).name.indexOf("QuestionForm_") >= 0) {
						qurrentQuestion = getQuestion(children[j].id.substr(children[j].id.lastIndexOf('_')+1));
						break;
					}
				} 			

				if (typeof(qurrentQuestion) != 'undefined' || qurrentQuestion != null ) {
					var elemNumber = sources[i].id.substr(14);
					
					if (qurrentQuestion.getParamValue("result") == "correct") { /////////// CORRECT ANSWER!
						passedIMQQuestions.push(qurrentQuestion.qid);
						img = document.getElementById("right_quizsource_item" + elemNumber);
					} else if(qurrentQuestion.getParamValue("result") == "incorrect") { ///////// INCORRECT ANSWER!
						passedIMQQuestions.push(qurrentQuestion.qid);
						img = document.getElementById("wrong_quizsource_item" + elemNumber);
					} else { ///////// user does not answer yet
						continue;
					}
					
					var target = document.getElementById("ImqLinkSpot" + elemNumber);
					var coords = target.coords.split(',');
					var imqOverlay = document.getElementById(imqOverlayId.toString());
					var elemOfsets = jQuery("#"+imqOverlayId).offset();
					img.style.left = findCenterPoly(coords,0) + elemOfsets.left - imgWidth/2 + "px";
					img.style.top = findCenterPoly(coords,1) + elemOfsets.top - imgHeight/2 + "px";
					img.style.visibility = "visible";
				}
			}
    }
}

// Extend basic Question type
ImageMapQuizQuestion.prototype = new Question;

// --------------------------------------
// --- add question to question array ---
function addImageMapQuizQuestion(question) {
    imqQuestions[imqQuestions.length] = question;
    addQuestion(question);
}

// -------------------------------------------------
// --- set parameters for all questions in array ---
function setImageMapQuizQuestions() {
	// not forms but divs
	var questionForms  = getElementsByName("div","QuestionForm");
	
    for (l=0; l < questionForms.length; l++) {
        var fid = questionForms[l].id;
        if (fid.toLowerCase().indexOf("imagemapquiz") == -1) continue;

        var wab_id = fid.substr(13);
        
        var wab_obj = document.getElementById("wab_"+wab_id);
        newImageMapQuizQuestion = new ImageMapQuizQuestion();
        newImageMapQuizQuestion.setParam("guid", wab_id);

        newImageMapQuizQuestion.setParam("attempts", 
                wab_obj.getAttribute("wab_AttemptLimit"));      
        newImageMapQuizQuestion.setParam("showHint", 
                wab_obj.getAttribute("wab_ShowHint"));  
        newImageMapQuizQuestion.setParam("showFeedback", 
                wab_obj.getAttribute("wab_ShowFeedback"));      
        newImageMapQuizQuestion.setParam("hintActive", 
                wab_obj.getAttribute("wab_hint_active"));       
        newImageMapQuizQuestion.setParam("corectAnswer", "");
        newImageMapQuizQuestion.setParam("rollupWeight", 
                wab_obj.getAttribute("wab_RollupWeight"));
        newImageMapQuizQuestion.setParam("questionsNumber", 
                wab_obj.getAttribute("wab_QuestionsNumber"));
        newImageMapQuizQuestion.setParam("minPassingScore", 
                wab_obj.getAttribute("wab_MinPassingScore"));
        newImageMapQuizQuestion.setParam("totalScore", 0);
        newImageMapQuizQuestion.setParam("totalWeight", 0);

                
        for (var j=0; j<questions.length; j++) {
            subwabid = "wab_" + questions[j].guid;
            if (jQuery("input[id*='" + subwabid + "']", questionForms[l]).length > 0) {
                questions[j].setParam("isSubQuestion", true);
                questions[j].setParam("parentQuestion", wab_id);
            }
        }
		
        addImageMapQuizQuestion(newImageMapQuizQuestion);
    }
}

// ------------------------------------------------------------
// --- handling submited form of ImageMapQuizquestion ---
function handleImageMapQuiz(chosenQuestId, qid, msg, redraw) {
	var popupElement = document.getElementById(chosenQuestId);
	// retrieving rendered div element (window with question)
	while (popupElement.id.indexOf("divImqLinkSpot") < 0) {
		popupElement = popupElement.parentNode;
	}
	hidePopup(popupElement);
	var currentQuestion = getQuestion(qid);
	var index = 0;//popupElement.id.substr(11);
	
	var quizId;
	var currentQuiz;
	
	
	var questionForms  = getElementsByName("div","QuestionForm");
	 for (l=0; l < questionForms.length; l++) {
        var fid = questionForms[l].id;
		
        if (fid.toLowerCase().indexOf("imagemapquiz") == -1) continue;

        quizId = fid.substr(13);
		currentQuiz = getQuestion(quizId);
	} 

	var at_limit = currentQuiz.getParamValue("attempts");	

    var shint = currentQuiz.getParamValue("showHint");	
	
	var wasQuestionPassed = false;	

	for (var i=0; i < passedIMQQuestions.length; i++) {
		if (passedIMQQuestions[i] == qid) {
			wasQuestionPassed = true;
		} 
	}

	if (!wasQuestionPassed) {
		var img;
		var target;
		var coords; 
		var isQuizDone;
		//substr number from id
		var elemNumber = popupElement.id.substr(14);
		
		passedIMQQuestions.push(qid);
		
		if (currentQuestion.getParamValue("result") == "correct") { /////////// CORRECT ANSWER!
			imqCorrectAnswers = imqCorrectAnswers + 1;
			img = document.getElementById("right_quizsource_item" + elemNumber);
			currentQuiz.totalScore += Number(currentQuestion.rollupWeight);
		} else { ///////// INCORRECT ANSWER!
			  img = document.getElementById("wrong_quizsource_item" + elemNumber);
		}
		currentQuiz.totalWeight += Number(currentQuestion.rollupWeight);
		target = document.getElementById("ImqLinkSpot" + elemNumber);
		coords = target.coords.split(',');
		var elemOfsets = jQuery("#"+imqOverlayId).offset();
				
		img.style.left = findCenterPoly(coords,0) + elemOfsets.left - imgWidth/2 + "px";
		img.style.top = findCenterPoly(coords,1) + elemOfsets.top - imgHeight/2 + "px"; 
		
		img.style.visibility = "visible";
		isQuestionDone = true;
	}

	if (passedIMQQuestions.length < currentQuiz.getParamValue("questionsNumber")) {
		isQuizDone = false;
	} else {
		isQuizDone = true;
	}
	 
	if (isQuizDone && at_limit >= 0) {
		var resultElems = getElementsByName("div","divResults");
		for  (var i = 0; i < resultElems.length; i++) {
				if (resultElems[i].getAttribute("mincorrect") <= imqCorrectAnswers &&
				imqCorrectAnswers <= resultElems[i].getAttribute("maxcorrect") && mode != "review") {
				renderPopup(resultElems[i].id);
			} 
		}
		if (at_limit > 0) {
			at_limit -= 1;
			currentQuiz.setParam("attempts",at_limit);
			currentQuiz.setParam("userAnswer", quizId + "|" + imqCorrectAnswers);
			if (currentQuiz.totalScore/currentQuiz.totalWeight*100 >= currentQuiz.minPassingScore)
				currentQuiz.setParam("result", "correct");
			else
				currentQuiz.setParam("result", "incorrect");
			//setAttemptCount(currentQuiz.guid, at_limit);
			currentQuiz.setUserResult(); //send result to CRE here!
			setUserResults();
		}
	}
}

var cachedOnMouseOut = new Array();
var	cachedOnMouseDown = new Array();
var	cachedOnMouseOver = new Array();
	
function removeImqOnMouseEvents() {
	for (var i=0; i < IMQ_HOT_SPOT_COUNT; i++) {

		var elem = document.getElementById('ImqLinkSpot' + i);
		if (elem != null) {
			cachedOnMouseOut[i] = elem.onmouseout;
			cachedOnMouseDown[i] = elem.onmousedown;
			cachedOnMouseOver[i] = elem.onmouseover;
			elem.onmouseout = null;
			elem.onmousedown = null;
			elem.onmouseover = null;
		}
	}
	j$('.ImageMapQuizBody area').unbind('keydown');
	j$('.ImageMapQuizBody area').unbind('focusin');    
}

function renewImqOnMouseEvents() {
	for (var i=0; i < IMQ_HOT_SPOT_COUNT; i++) {

		var elem = document.getElementById('ImqLinkSpot' + i);
		if (elem != null) { 
			elem.onmouseout = cachedOnMouseOut[i];
			elem.onmousedown = cachedOnMouseDown[i];
			elem.onmouseover = cachedOnMouseOver[i];
		}
	}
	j$('.ImageMapQuizBody area').bind({
		keydown : function(event){
			bindKeyDown(event);
		},
		focusin : function (){
			bindFocusIn(this)	
		}
	});
}
  
function renderPopup(chosenAnwId, qid) {
	var popupQuestion = document.getElementById(chosenAnwId);
	popupQuestion.className = "imqShownContent";

	if (IMQ_DISPLAY_AREA_SPECIFIED == null || !IMQ_DISPLAY_AREA_SPECIFIED || chosenAnwId.indexOf("Results")!=-1) {
		popupQuestion.style.left = "20px";
		popupQuestion.style.top = "20px";
	}
	
	popupQuestion.style.display = "block"; 
	popupQuestion.style.visibility = "visible";
	globoffsetLeft = popupQuestion.offsetLeft; 
	globoffsetTop = popupQuestion.offsetTop;
	removeImqOnMouseEvents();
	
	var popupWindow  = document.getElementById("IMQPopup");
	popupWindow.style.display = "block";
	popupWindow.style.visibility = "visible";	
	var bdimageOffsetLeft = 0;
	var bdimageOffsetTop = 0;
	
	if(popupQuestion.childNodes[1] != null && popupQuestion.childNodes[1].className == 'ImageMapAssessment'){
		var imgmapelm = (document.getElementById('imagemaphiddendata')).attributes[2].nodeValue;
		var imgampcount = (document.getElementById('imagemaphiddendata')).attributes[3].nodeValue;
		var imgmapcolor = (document.getElementById('imagemaphiddendata')).attributes[1].nodeValue;
		offsets[imgampcount] = getOffset(document.getElementById(imgmapelm));
		outlinemaps[imgampcount] = new jsGraphics(document.getElementById('outlinemap0'));
		outlinemaps[imgampcount].setColor(imgmapcolor);
	}
}


function hidePopup(popupElement) {
	// retrieving rendered div element (window with question)
	popupElement.className = "imqHiddenContent";
	popupElement.style.display = "none"; 
	popupElement.style.visibility = "hidden";
	document.getElementById("IMQPopup").style.display = "none";
	renewImqOnMouseEvents();
}

function hideIMQHints(qid) {
	var displayArea = document.getElementById("display_" + qid);
    if(displayArea != null) {
        displayArea.innerHTML = "";
    }
}

function showIMQHint(qid, alt) {
    var displayArea = document.getElementById("display_" + qid);
    if(displayArea != null) {
        displayArea.innerHTML = alt;
    }
}

// -------------------------------
// --- init the whole CRE page ---
function initImageMapQuizPage() {    
    setImageMapQuizQuestions();
    getUserResults(imqQuestions);
	var contentCover = document.getElementById('IMQContentCover');

    if(contentCover) {
		/*done to make offsets correct in questions (prevent dragging objects' shifting) */
		var container = document.getElementById("imqQuestionsContainer");
		for (var i = 0 ; i < container.childNodes.length; i++){
			container.childNodes[i].className = "imqHiddenContent";
		}
		container = document.getElementById("imqPopupContainer");
		for (var i = 0 ; i < container.childNodes.length; i++){
			if(container.childNodes[i].nodeName != '#text'){
				container.childNodes[i].className = "imqHiddenContent";
			}
		}
		/***/
        contentCover.style.visibility = 'hidden';
    }
}
function hideOutlineMapsIMQ(){
	for (var i = 0; i < imqoutlinemaps.length; i++) {
		if (imqoutlinemaps[i] != null) {
			imqoutlinemaps[i].clear();
		}
	}
}

jQuery(document).ready(function areaBind(){
	j$('.ImageMapQuizBody area').bind({
		keydown : function(event){
			bindKeyDown(event);
		},
		focusin : function (){
			bindFocusIn(this)
		}
	});
});

function bindKeyDown(event){
	hideOutlineMapsIMQ();
	//space or enter was pressed
	if (event.keyCode == 32 || event.keyCode == 13) {
		var target = event.currentTarget;
		if ( j$.browser.msie && target != null) {
			target = selectedArea;
		}
		renderPopup("div" + target.id, j$('#' + target.id).attr("questionid"));
	}
}

function bindFocusIn(value){
	if ( j$.browser.msie ) {
		selectedArea = value;	
	}
	var target = value;
	if (typeof(target) == "undefined" || target == null) {
		return;
	}
	drawImqFigure(target, false);
}

//window.onload = initQuestionPage();
