/*

Copyright c 2013 Xyleme, Inc., 1881 9th Street, Suite 300, Boulder, Colorado 80302 USA.
All rights reserved.

This file and related documentation are protected by copyright and
are distributed under licenses regarding their use, copying, distribution,
and decompilation. No part of this product or related documentation may
be reproduced or transmitted in any form or by any means, electronic or
mechanical, for any purpose, without the express written permission of
Xyleme, Inc.

*/


var stepHeights = new Array();

function showHideStep(id) {
	var step = document.getElementById(id);
    if(step.down) {
		step.glidetime=1000;
        step.down = false;
		slideengine(step, "up", new Date().getTime());
    } else {
        step.glidetime=1000;
        step.down = true;
         if(document.getElementById(id + "Body").offsetHeight > stepHeights[id])
            stepHeights[id] = document.getElementById(id + "Body").offsetHeight;
		slideengine(step, "down", new Date().getTime());
        for(i in stepHeights) {
            if(i != id && document.getElementById(i).down) {
                stepI = document.getElementById(i);
                stepI.glidetime=1000;
                stepI.down = false;
                slideengine(stepI, "up", new Date().getTime());
            }
        }
	}
}

function toggleResource(id) {
    if (jQuery("div#" + id).css("display") == "none") {
        jQuery("div.TypeContent:visible").slideUp("slow");
        jQuery("div#" + id).slideDown("slow");
    } else {
        jQuery("div#" + id).slideUp("slow");
    }
}
	
function slideengine(obj, direction, startTime){
	var elapsed=new Date().getTime()-startTime //get time animation has run
	if (elapsed<obj.glidetime){ //if time run is less than specified length
		var distancepercent=(direction=="down")? curveincrement(elapsed/obj.glidetime, false) : curveincrement(elapsed/obj.glidetime, true)
		var currentclip=(distancepercent*stepHeights[obj.id])+"px"
		obj.style.height = currentclip;
		window["glidetimer_"+obj.id]=setTimeout(function(){slideengine(obj, direction, startTime)}, 10)
	}
	else{ //if animation finished
		if (direction=="up") {
            obj.style.height = "0px";
		}
	}
}

function curveincrement(percent, hide){
	if (hide)
		return (Math.cos(percent*Math.PI/2))  //return cos curve based value from a percentage input
	else 
		return (1 - Math.cos(percent*Math.PI/2)) //return cos curve based value from a percentage input
}