/*

Copyright c 2013 Xyleme, Inc., 1881 9th Street, Suite 300, Boulder, Colorado 80302 USA.
All rights reserved.

This file and related documentation are protected by copyright and
are distributed under licenses regarding their use, copying, distribution,
and decompilation. No part of this product or related documentation may
be reproduced or transmitted in any form or by any means, electronic or
mechanical, for any purpose, without the express written permission of
Xyleme, Inc.

*/

// global vars
top.tocloaded = 0;
top.searchloaded = 0;

//================================
// functions for IA html frameset
//
// switchTab(tab) - switches tabs without reloading the content
// setFocus(tab) - sets focus on first element in tab (first link or search input)
// loadTOC() - loads toc (XSLT of IA webcourse) to navigation pane
// submitSearch() - submits search form (creates search request url
//

//---------------------
function switchTab(tab) 
{
    document.getElementById("tab-toc").className = "back";;
    document.getElementById("tab-search").className = "back";;
    var active = document.getElementById("tab-"+tab);
    active.className = "front";

    var loc = top.location.protocol + "//" + top.location.host.toString() + top.location.pathname.toString();
    last = loc.lastIndexOf("/");
    loc = loc.substring(0,last+1) + tab + ".html";
    //alert("loc: " + loc);
	 
    loc = tab + ".html";
    //alert(top.tocloaded);
    if (tab == "toc") {
	var fms = parent.document.getElementsByTagName("frameset")[0];
	fms.setAttribute("rows","60,*,0");
    }
    if (tab == "search") {
	//alert(top.searchloaded);
	if (top.searchloaded == 0) {
	    parent.search.location.href = loc;
	}
	var fms = parent.document.getElementsByTagName("frameset")[0];
	fms.setAttribute("rows","60,0,*");
    }
    
    setFocus(tab);
}

//---------------------
function setFocus(tab) {
    //tbd   
}

//---------------------
function loadTOC() {
    if (top.tocloaded == 0) {	
		location = "toc.html"
		top.tocloaded = 1;
    }
}

function loadPageBlank() {
 	var path = "/europa/crs?";
	var query = top.location.search.toString().substr(1);
	//alert("redirecting to: " + top.location.protocol + "//" + top.location.host + path + query);
	var fullpath = top.location.protocol + "//" + top.location.host + path + query;
	fullpath = fullpath.replace("ia_fstree", "ia_cp");
	location.replace(fullpath);
}

function loadSearch() {
    //if (searchloaded == 0) {
	var path = "/europa/crs?";
	var query = top.location.search.toString().substr(1);
	//alert("redirecting to: " + top.location.protocol + "//" + top.location.host + path + query);
	var fullpath = top.location.protocol + "//" + top.location.host + path + query;
	fullpath = fullpath.replace("ia_fstree", "ia_fssearch");
	location.replace(fullpath);
	//tocloaded = 1;
    //}
}

//---------------------
function submitSearch() {
    var form = document.forms["searchForm"];
    var term = form.elements["search"].value;
    var path = "/europa/crs?action=cslsearch&search_term=";
    var query = top.location.search.toString().substr(23);
    var searchurl = top.location.protocol + "//" + top.location.host + path + term + query;
    //    alert(searchurl.substring(0,50) + "\n" + searchurl.substring(50,100) + "\n" + searchurl.substring(100,150) + "\n" + searchurl.substring(150,200) + "\n" + searchurl.substring(200,250) + "\n" + searchurl.substring(250,300) + "\n" + searchurl.substring(300,350) + "\n"); 

    form.action = searchurl;
    form.submit();
    top.searchloaded = 1;
}

function expandOrCollapse(elemGUID) {

	var linkElem = document.getElementById(elemGUID)
	var childrenElemId = elemGUID + "_children";
	var childrenElem = document.getElementById(childrenElemId);	
	
	if (childrenElem == null || typeof(childrenElem)=='undefined')
		return;
	
	var imgElem = linkElem.getElementsByTagName("img").item(0); //previousObject(linkElem);
	if (childrenElem.style.display=='none'){
		childrenElem.style.display = 'inline';
		imgElem.setAttribute("src", "ContentPackages/IA/Transforms/Html_frameset/images/minus.gif");		
		linkElem.blur();
	} else { 
		childrenElem.style.display = 'none';
		imgElem.setAttribute("src", "ContentPackages/IA/Transforms/Html_frameset/images/plus.gif");		
	}
} 

function previousObject(element) {	
	do element = element.previousSibling;
	while (element && element.nodeType != 1);
	return element;
}
