/*

Copyright c 2013 Xyleme, Inc., 1881 9th Street, Suite 300, Boulder, Colorado 80302 USA.
All rights reserved.

This file and related documentation are protected by copyright and
are distributed under licenses regarding their use, copying, distribution,
and decompilation. No part of this product or related documentation may
be reproduced or transmitted in any form or by any means, electronic or
mechanical, for any purpose, without the express written permission of
Xyleme, Inc.

*/

var TOC;
var Content;
var europaPath = "/europa/";
// no hacks for IE8
var isIE  = ((navigator.appVersion.indexOf("MSIE") != -1) && (parseFloat(navigator.appVersion.split("MSIE")[1]) <= 7)) ? true : false;

function button (img) {
	this.src = img;
	this.enadled = false;
}

var nextEnabled = false;
var prevEnabled = false;

function next() {
	if(nextEnabled) {
		var nextNode = TOC.currentNode;
		nextNode++;
		
		while (nextNode < TOC.nodes.length) {
			var link = TOC.document.getElementById(TOC.nodes[nextNode]);
			setTocActive(link);
			
			if(link.toString().indexOf("javascript") == -1) {	
				//Content.location.href = link.getAttribute('href');
				Content.location.href = link;
				TOC.currentNode = nextNode;
				break;
			} else {
				nextNode++;
			}
		}
		refreshControls(nextNode);
	}
}

function prev() {
	if(prevEnabled) {
		var prevNode = TOC.currentNode;
		prevNode--;
		
		while (prevNode >= 0) {
			var link = TOC.document.getElementById(TOC.nodes[prevNode]);
			setTocActive(link);
			
			if(link.toString().indexOf("javascript") == -1) {	
				Content.location.href = link;
				TOC.currentNode = prevNode;
				break;
			} else {
				prevNode--;
			}
		}
		refreshControls(prevNode);
	}
}

function init(newTOC) {
	TOC = newTOC;
	Content = parent.frames['content'];
	refreshControls(-1);
	var activeElement = TOC.document.getElementsByName("t1");
	activeElement[0].style.color = "#F60909";	
}

function enableNext() {
	if(!nextEnabled) {
		document.getElementById("nextImg").src = "images/next.gif";
		nextEnabled = true;
	}
}

function enablePrev() {
	if(!prevEnabled) {
		document.getElementById("prevImg").src = "images/prev.gif";
		prevEnabled = true;
	}
}

function disableNext() {
	if(nextEnabled) {
		document.getElementById("nextImg").src = "images/nextx.gif";
		nextEnabled = false;
	}
}

function disablePrev() {
	if(prevEnabled) {	
		document.getElementById("prevImg").src = "images/prevx.gif";
		prevEnabled = false;
	}
}

function refreshControls(currentNode) {
	if(currentNode == -1) {
		enableNext();
		disablePrev();
	} else if(currentNode == 0) {
		enableNext();
		disablePrev();
	} else if(currentNode == TOC.nodes.length-1) {
		disableNext();
		enablePrev();
	} else {
		enableNext();
		enablePrev();
	}
}

function setTocActive(activeElement) {
	var treeElements = TOC.document.getElementsByName("t1");
				
	for (var i = 0; i < treeElements.length; i++) {
		treeElements[i].style.color="#315585";
	}
	treeElements = TOC.document.getElementsByName("t2");
	for (var i = 0; i < treeElements.length; i++) {
		treeElements[i].style.color="#315585";
	}
	treeElements = TOC.document.getElementsByName("t3");
	for (var i = 0; i < treeElements.length; i++) {
		treeElements[i].style.color="#315585";
	}
	
	treeElements = TOC.document.getElementsByName("t4");
	for (var i = 0; i < treeElements.length; i++) {
		treeElements[i].style.color="#315585";
	}
	activeElement.style.color = "#F60909";		
}