/*

Copyright c 2013 Xyleme, Inc., 1881 9th Street, Suite 300, Boulder, Colorado 80302 USA.
All rights reserved.

This file and related documentation are protected by copyright and
are distributed under licenses regarding their use, copying, distribution,
and decompilation. No part of this product or related documentation may
be reproduced or transmitted in any form or by any means, electronic or
mechanical, for any purpose, without the express written permission of
Xyleme, Inc.

*/

var closedImg = "ContentPackages/IA/Transforms/Html_frameset/images/fc.gif";
var openImg = "ContentPackages/IA/Transforms/Html_frameset/images/fo.gif";

var nodes = new Array();
var currentNode = -1;

var titleFrame;

//click on link
function onLinkClick(id) {
	setCurrentNode(id);
}
function initNavigation() {
	//init Title frame
	
	var top = parent;
	while (top.parent != null && top.parent != top) top = top.parent;

	titleFrame = top.frames['frameset'];
	if(typeof(titleFrame) == 'undefined' || titleFrame == null) {
		return;
	}
	titleFrame = titleFrame.frames['content_frame'];
	if(typeof(titleFrame) == 'undefined' || titleFrame == null) {
		return;
	}
	contentFrame = titleFrame.frames['content'];
	titleFrame = titleFrame.frames['title'];
	if(typeof(titleFrame) == 'undefined' || titleFrame == null) {
		return;
	}
	titleFrame.init(this);
	
	//init nodes array
	var items = document.getElementsByTagName("a");
	var nodesCount = 0;
	for(var i=0; i<items.length; i++) {
		var nextId = items[i].getAttribute('id');
		if(nextId != null && nextId.indexOf(nodes[nodesCount-1]) != 0 && items[i].getAttribute("href").indexOf("javascript") == -1) {
			nodes[nodesCount++] = nextId;
		}
	}
	currentNode = 1;
	var el = document.getElementsByTagName("a")[1];
	contentFrame.location = el.href;
	setTocActive(el);
}

function setCurrentNode(id) {
	if(id != null) {
	//	var currLink = document.getElementById(nodes[currentNode]);	
		//find id in the array
		for(var i=0; i<nodes.length; i++) {
			if(id.indexOf(nodes[i]) == 0) {
				currentNode = i;
				break;
			}
		}
		// new current node
	//	var link = document.getElementById(nodes[currentNode]);
	//	updateActiveNode(currLink, link);
		
	} else
		currentNode = -1;
	titleFrame.refreshControls(currentNode);
}

function updateActiveNode(currLinkElement, newLinkElement) {
	if (currLinkElement)
		currLinkElement.style.color="#014165";
	if (newLinkElement)
		newLinkElement.style.color="#F60909";
}

function setTocActive(activeElement) {
	var treeElements = document.getElementsByName("t1");
				
	for (var i = 0; i < treeElements.length; i++) {
		treeElements[i].style.color="#315585";
	}
	treeElements = document.getElementsByName("t2");
	for (var i = 0; i < treeElements.length; i++) {
		treeElements[i].style.color="#315585";
	}
	treeElements = document.getElementsByName("t3");
	for (var i = 0; i < treeElements.length; i++) {
		treeElements[i].style.color="#315585";
	}
	
	treeElements = document.getElementsByName("t4");
	for (var i = 0; i < treeElements.length; i++) {
		treeElements[i].style.color="#315585";
	}
	activeElement.style.color = "#F60909";		
}